* Visual FoxPro 6 example 2 how to use BigSpeed Zip DLL

* Task - Create a zip file and add (compress) file into it

****************************************************************
* step 1. create the zip file
*         x = zCreateNewZip( "ZipFileName.zip")
* step 2. do one time for every file to be added to the zip
*         y = zOrderFile( "FullPath_and_FileName.txt", "ShortFileName", Update_mode)
* step 3. write the zip file to disk
*         x = zCompressFiles( "TempDir", "Password", compress_type, Reset_Archive_Bit, Return_Function)
* step 4. close the file
*         x = zCloseZipFile()
* if x <> 0 in each of above there was an error
*  WAIT WINDOW zGetLastErrorAsText()

****************** program variables
zFullTxt = ""     && the FULL Path and file name of the file to zip
zTxtName = ""     && the FILE Name only of the file to zip
zfn =      ""     && the name of the NEW Zip file we will create
zerr_no =  0      && test the valid status
item_num = 0      && number of items to be compressed
****************** end of variables

zFullTxt = getfile( "*", "Select File", "Select", 0, "Locate the file to Zip")
if empty( zFullTxt )
   return
endif
zTxtName = substr( zFullTxt, rat("\", zFullTxt) + 1) && extract file name from the path


tmpdir = ""  &&use the default temporary directory
zfn = "C:\TEMP\TEST.ZIP"  && do what what you need here to get the file name. If you want the Zip to be in another directory include it in the zfn
* MAKE Sure that is has a .zip extension!

* Program starts here
clear dlls
declare integer zCreateNewZip in bszip string zipFileName
declare integer zOrderFile in bszip string zFullTxt, string zTxtName, integer zUpdateMode
declare integer zCompressFiles in bszip string tmpdir, string zPass, integer zCompressMethod, integer zResetArchiveAttribute, integer SpanSize, string ZipComment, integer RTFunction
declare integer zCloseZipFile in bszip
declare string zGetLastErrorAsText in bszip

zerr_no = zCreateNewZip( zfn )
if zerr_no <> 0   && there was an error creating the zip file
   wait window zGetLastErrorAsText()
   return
endif

* you can put this in a loop and add files from an array or table
* for i = 1 to alen( array_name, 1)
*    zFullTxt = array_name( i, 1)
*    zTxtName = substr( zFullTxt, rat("\", zFullTxt) + 1)
     if zOrderFile( zFullTxt, zTxtName, 0) = 0
        item_num = item_num + 1
     endif
* endfor


* Do compression
if item_num > 0
	zerr_no = zCompressFiles("", "", 2, .f., 0, "", 0)  && Normal Compression
	if zerr_no <> 0
	   wait window zGetLastErrorAsText()
	endif
endif

= zCloseZipFile()
clear dlls

