* Visual FoxPro 6 example 1 how to use BigSpeed Zip DLL

* Task - Open a zip file and extract (decompress) its contents

********************* variables used in this program
* variables used
num_items = 0        && number of items in the file 
z_e_num = 0          && error trap
zfn = ""             && Zip File Name
z_err = ""           && error string
extr_dir = ""           && Complete path where files will be extracted, Leave Blank for same dir as zip file
********************* end of variables


* Program starts here
*******************************************************************
zfn = getfile("zip", "Select Directory", "Select", 0, "Locate the Zip File")
if empty( zfn )
   return
endif

chdir ( home() )  && Lets make sure that FoxPro can find the DLL!
clear dlls        && Lets make sure no other librarys are loaded
declare integer zOpenZipFile in bszip string zipfilename
declare integer zCloseZipFile in bszip
declare integer zGetTotalFiles in bszip
declare string zGetFileName in bszip integer item
declare integer zGetFileSize in bszip integer item
declare string zGetLastErrorAsText in bszip
declare string zGetLastOperResult in bszip integer item
declare integer zExtractAll in bszip string extractdir, string pswd, integer OverwriteExisting, integer SkipOlder, integer UseFolders, integer TestOnly, integer RTInfoFunc


z_e_num = zOpenZipFile( zfn )
if z_e_num <> 0   && there is an error
   z_err = zGetLastErrorAsText()
   = messagebox("Error Opening Zip file [" + zfn + "]  " + chr(13) + z_err, 0, "Press 'ENTER' to Continue")
endif

*test integrity of all files
if z_e_num = 0
   z_e_num = zExtractAll( '', '' , .t., .f., .f., .t., 0)
   if z_e_num <> 0
      z_err = zGetLastErrorAsText()
      = messagebox("Error Testing Zip file [" + zfn + "]  " + chr(13) + z_err, 0, "Press 'ENTER' to Continue")
   endif
endif

*get number of items in zip file
if z_e_num = 0
   num_items = zGetTotalFiles() -1
   *iterate on list of items and show file name and file size
   for i = 0 to num_items do
      ? str(i,4) + ' ' + zGetFileName( i )+ ' ' + str( zGetFileSize( i ), 12)
   endfor
endif

extr_dir = getdir("", "Extract to directory")

* extract files
if z_e_num = 0
   if zExtractAll( (extr_dir), '', .t. , .f., .f.,  .f., 0) <> 0
      z_err = zGetLastErrorAsText()
      = messagebox("Error Extracting Files in [" + zfn + "]  " + chr(13) + z_err, 0, "Press 'ENTER' to Continue")
   endif
endif


=zCloseZipFile()
clear dlls
wait window 'Press a key to continue...'

